                  
// file  Tree23.h  
//   2-3  
//   
   
#pragma once
#include <iostream>
using namespace std;                  

//      2 
template <class T>
struct TreeNode2 {
   T value;
   TreeNode2 *first, *second;
   TreeNode2() { first = second = nullptr; }
   virtual int Size() { return 1; }
   virtual int Test(const T &x) {
      return (x < value) ? 1 : 2;
   } 
};

//      3 
template <class T>
struct TreeNode3 : public TreeNode2<T> {
   T value2;
   TreeNode2<T> *third;
   TreeNode3() : TreeNode2<T>() { third = nullptr; }
   int Size() { return 2; }
   int Test(const T &x) {
      return (x < this->value) ? 1 : (x < value2) ? 2 : 3;
   }
};


//  2-3 
//   

template <class T>
class Tree23
{
    TreeNode2<T> * root;

    bool Add(T &x,  TreeNode2<T> *p,  TreeNode2<T> *&q1, TreeNode2<T> *&q2);
    void RPrint(TreeNode2<T> *p);

public:
    Tree23() { root = 0; }
    void Add(const T &x);
    void Print() { RPrint(root); }
    ~Tree23() { /*   */ }
};


//   x     p,
//     ,  true      q1
//   ,   false, q1  q2       
//  x -  ,      

template <class T>
bool Tree23<T>::Add( T &x,  TreeNode2<T> *p,  TreeNode2<T> *&q1, TreeNode2<T> *&q2)
{

   int k = p->Test(x); //  
   TreeNode2<T> *pp; //    

//cout << "at " << p << " add " << x << endl;

   //   
   if (p->first) {  //    
      switch(k) {  //   
      case 1:
          if (Add(x, p->first, q1, q2)) { 
             p->first = q1;
             q1 = p;
             return true;
          }
          break;
      case 2: 
          if (Add(x, p->second, q1, q2)) { 
             p->second = q1;
             q1 = p;
             return true;
          } 
          break;
      case 3: 
          if (Add(x, dynamic_cast<TreeNode3<T>*>(p)->third, q1, q2)) { 
             dynamic_cast<TreeNode3<T>*>(p)->third = q1;
             q1 = p;
             return true;
          } 
          break;
      }
   } else {
       q1 = q2 = nullptr;
   }
   //    x   
   // , q1  q2    
 
   if (p->Size() == 1) { //    TreeNode3  
      pp = new TreeNode3<T>;
      switch(k) {  //      
      case 1:
         pp->value = x;
         dynamic_cast<TreeNode3<T>*>(pp)->value2 = p->value;
         pp->first = q1;
         pp->second = q2;
         dynamic_cast<TreeNode3<T>*>(pp)->third = p->second;
         break;
      case 2:
         pp->value = p->value;
         dynamic_cast<TreeNode3<T>*>(pp)->value2 = x;
         pp->first = p->first;
         pp->second = q1;
         dynamic_cast<TreeNode3<T>*>(pp)->third = q2;
         break;
      }
      delete p; //    
      q1 = pp;  //    
      return true;
   } else { //     TreeNode2  
      pp = new TreeNode2<T>;
      TreeNode2<T> *qq = new TreeNode2<T>;
      switch(k) {
      case 1:
          pp->value = x;
          pp->first = q1;
          pp->second = q2;
          qq->value = dynamic_cast<TreeNode3<T>*>(p)->value2;
          qq->first = p->second;
          qq->second = dynamic_cast<TreeNode3<T>*>(p)->third;
          x = p->value;
          break;
      case 2:
          pp->value = p->value;
          pp->first = p->first;
          pp->second = q1;
          qq->value = dynamic_cast<TreeNode3<T>*>(p)->value2;
          qq->first = q2;
          qq->second = dynamic_cast<TreeNode3<T>*>(p)->third;
          // x      
          break;
      case 3:
          pp->value = p->value;
          pp->first = p->first;
          pp->second = p->second;
          qq->value = x;
          qq->first = q1;
          qq->second = q2;
          x = dynamic_cast<TreeNode3<T>*>(p)->value2;
          break;
      }
      delete p;
      q1 = pp;
      q2 = qq;
      return false;
   }
}


template <class T>
void Tree23<T>::Add(const T &x)
{
    T xx = x;
    TreeNode2<T> *p; //    
    TreeNode2<T> *q1, *q2;

    if (root) {
       if (Add(xx, root, q1, q2)) { //   
          root = q1;
       } else {
          //    -   
          p = new TreeNode2<T>;
          p->value = xx;
          p->first = q1;
          p->second = q2;
          root = p;
       }
    } else {
       //    
       root = new TreeNode2<T>;
       root->value = xx;
    }
}

//    -
template <class T>
void Tree23<T>::RPrint(TreeNode2<T> *p)
{
   //cout << p << "-----------\n";
   if (p==nullptr) return;
   cout << p << "[" << p->Size() << "] : " << p->value;
   if (p->Size() == 2) cout << " " << dynamic_cast<TreeNode3<T>*>(p)->value2;
   cout << "  (" << p->first << " " << p->second;
   if (p->Size() == 2) cout << " " << dynamic_cast<TreeNode3<T>*>(p)->third;
   cout << ")\n";
   
   RPrint(p->first);
   RPrint(p->second);
   if (p->Size() == 2) RPrint(dynamic_cast<TreeNode3<T>*>(p)->third);

 }



/****************************************************************************
  -   

#include "Tree23.h"

int main()
{
    Tree23<int> t;
    t.Add(1);
    t.Add(2);
    t.Add(3);
    t.Add(4);
    t.Add(5);
    t.Add(6);
    t.Add(7);
    t.Add(8);
    t.Add(9);
    t.Add(10);
    cout << "==============================\n";
    t.Print();
    return 0;
}



****************************************************************************/
